# Copyright 1999-2015 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Id$

EAPI=5
PYTHON_COMPAT=( python2_7 python3_3 python3_4 )

inherit distutils-r1

DESCRIPTION="Oslo test framework"
HOMEPAGE="http://launchpad.net/oslo"
SRC_URI="mirror://pypi/${PN:0:1}/${PN}/${P}.tar.gz"

LICENSE="Apache-2.0"
SLOT="0"
KEYWORDS="amd64 ~x86 ~amd64-linux ~x86-linux"
IUSE="doc test"

CDEPEND=">=dev-python/pbr-1.8[${PYTHON_USEDEP}]"
DEPEND="
	dev-python/setuptools[${PYTHON_USEDEP}]
	${CDEPEND}
	test? ( >=dev-python/oslo-config-2.3.0[${PYTHON_USEDEP}] )
	>=dev-python/oslo-sphinx-2.5.0[${PYTHON_USEDEP}]
	>=dev-python/sphinx-1.1.2[${PYTHON_USEDEP}]
	!~dev-python/sphinx-1.2.0[${PYTHON_USEDEP}]
	<dev-python/sphinx-1.3[${PYTHON_USEDEP}]
"
RDEPEND="
	>=dev-python/fixtures-1.3.1[${PYTHON_USEDEP}]
	>=dev-python/mock-1.2[${PYTHON_USEDEP}]
	>=dev-python/mox3-0.7.0[${PYTHON_USEDEP}]
	>=dev-python/os-client-config-1.4.0[${PYTHON_USEDEP}]
	!~dev-python/os-client-config-1.6.2[${PYTHON_USEDEP}]
	>=dev-python/six-1.9.0[${PYTHON_USEDEP}]
	>=dev-python/subunit-0.0.18[${PYTHON_USEDEP}]
	>=dev-python/testrepository-0.0.18[${PYTHON_USEDEP}]
	>=dev-python/testscenarios-0.4[${PYTHON_USEDEP}]
	>=dev-python/testtools-1.4.0[${PYTHON_USEDEP}]
"

python_compile_all() {
	if use doc; then
	 	esetup.py build_sphinx
	else
		esetup.py build_sphinx -b man
	fi
}

python_test() {
	rm -rf .testrepository || die "couldn't remove '.testrepository' under ${EPYTHON}"

	testr init || die "testr init failed under ${EPYTHON}"
	testr run || die "testr run failed under ${EPYTHON}"
}

python_install_all() {
	doman doc/build/man/oslotest.1
	use doc && local HTML_DOCS=( doc/build/html/. )

	distutils-r1_python_install_all
}
